#!/bin/bash

#FTR shell scripting sucks

USE_POVRAY_VERSION='3.7;//.0.RC4.2(pacman)'

ATM_H=0.03
CLOUD_H=0.015

CLOUD_RND=$RANDOM
CLOUD_ANGLE_RND=$RANDOM

OTHER_TEXTURE='//nothing'

W=800
H=800

CLOUD_POW=0.7
SUN_HEAT=1

VIEW_ANGLE=$RANDOM
CLOCK="$VIEW_ANGLE+mod($RANDOM,1.5)" #Hope to keep the sun at our side.

while getopts ":d:a:c:r:R:v:K:p:o:w:h:s:v:" Option
do
  case $Option in
    d     ) DIR=$OPTARG ;;
    a     ) ATM_H=$OPTARG ;;
    c     ) CLOUD_H=$OPTARG ;;
    r     ) CLOUD_RND=$OPTARG ;;
    R     ) CLOUD_ANGLE_RND=$OPTARG ;;
    v     ) USE_POVRAY_VERSION=$OPTARG ;;
    K     ) CLOCK=$OPTARG ;;
    p     ) CLOUD_POW=$OPTARG ;;
    o     ) OTHER_TEXTURE=$OPTARG ;;
    w     ) W=$OPTARG ;;
    h     ) H=$OPTARG ;;
    s     ) SUN_HEAT=$OPTARG ;;
    v     ) VIEW_ANGLE=$OPTARG ;;
  esac
done

cp terran-povray-for-script.pov $DIR/script.pov
cd $DIR

echo at `pwd`, 'replacing words in pov file..'

replace ATM_H $ATM_H \
        CLOUD_H $CLOUD_H \
        CLOUD_RND $CLOUD_RND \
        CLOUD_ANGLE_RND $CLOUD_ANGLE_RND \
        CLOUD_POW $CLOUD_POW \
        USE_POVRAY_VERSION $USE_POVRAY_VERSION \
        OTHER_TEXTURE $OTHER_TEXTURE \
        SUN_HEAT $SUN_HEAT \
        VIEW_ANGLE $VIEW_ANGLE \
   -- script.pov 

NAME_IT=`date +%s`
echo "TEXTURE_FROM_DIR $DIR
ATM_H $ATM_H
CLOUD_H $CLOUD_H
CLOCK $CLOCK
CLOUD_POW $CLOUD_POW
CLOUD_RND $CLOUD_RND 
CLOUD_ANGLE_RND $CLOUD_ANGLE_RND
USE_POVRAY_VERSION $USE_POVRAY_VERSION
SUN_HEAT $SUN_HEAT 
VIEW_ANGLE $VIEW_ANGLE
OTHER_TEXTURE $OTHER_TEXTURE" > $NAME_IT.info

cat $NAME_IT.info

echo 'done, run povray'

povray script.pov -W$W -H$H -K$CLOCK
mv script.png $NAME_IT.png
